`GriffonModelClass.java`
`01 /* 02 * Copyright 2010-2012 the original author or authors. 03 * 04 * Licensed under the Apache License, Version 2.0 (the "License"); 05 * you may not use this file except in compliance with the License. 06 * You may obtain a copy of the License at 07 * 08 * http://www.apache.org/licenses/LICENSE-2.0 09 * 10 * Unless required by applicable law or agreed to in writing, software 11 * distributed under the License is distributed on an "AS IS" BASIS, 12 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 13 * See the License for the specific language governing permissions and 14 * limitations under the License. 15 */ 16 package griffon.core; 17 18 /** 19 * Represents a Model class in Griffon.<p> 20 * 21 * @author Andres Almiray 22 * @since 0.9.1 23 */ 24 public interface GriffonModelClass extends GriffonClass { 25 /** 26 * "model" 27 */ 28 String TYPE = "model"; 29 /** 30 * "Model" 31 */ 32 String TRAILING = "Model"; 33 34 /** 35 * Matches all public properties that are not event handlers nor 36 * have a Closure as their value.<p> 37 * 38 * @return an array containing the names of all model properties. 39 */ 40 String[] getPropertyNames(); 41 42 /** 43 * Matches all public methods and closure properties whose name 44 * matches the event handler convention, i.e, starts with "on" and 45 * is followed by at least one uppercase character.<p> 46 * 47 * @return an array containing the names of all event handlers. 48 */ 49 String[] getEventNames(); 50 51 /** 52 * Sets a value of a model property. 53 * 54 * @param model the model to be affected 55 * @param propertyName the name of the property to update 56 * @param value new value 57 */ 58 void setModelPropertyValue(GriffonModel model, String propertyName, Object value); 59 60 /** 61 * Returns the value of a model property. 62 * 63 * @param model the model to query 64 * @param propertyName the name of the property to query 65 * @return the value of the property 66 */ 67 Object getModelPropertyValue(GriffonModel model, String propertyName); 68 }`